Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -142,12 +696,31 @@
             0x60 => 'Fluorescent',
             0x70 => 'Custom',
-        },
-    },
+            0x80 => 'Underwater',
+        },
+    },
+    # Tag 0x0116: extra hardware info (ref JR)
+    # (tag not present for A100, A200, A300, A350, A700, nor for A37, A57, A65, A77)
+    0x0116 => [ #JR
+        {
+            Name => 'ExtraInfo',
+            Condition => '$$self{Model} =~ /^DSLR-A(850|900)\b/',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Sony::ExtraInfo',
+                ByteOrder => 'BigEndian',
+            },
+        },{
+            Name => 'ExtraInfo2',
+            Condition => '$$self{Model} =~ /^DSLR-A(230|290|330|380|390)\b/',
+            SubDirectory => { TagTable => 'Image::ExifTool::Sony::ExtraInfo2' },
+        },{
+            Name => 'ExtraInfo3',
+            # for DSLR-A450/500/550/560/580, SLT-A33/35/55 and NEX-3/5/5C.
+            SubDirectory => { TagTable => 'Image::ExifTool::Sony::ExtraInfo3' },
+        }
+    ],
     0x0e00 => {
         Name => 'PrintIM',
         Description => 'Print Image Matching',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::PrintIM::Main',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::PrintIM::Main' },
     },
     # the next 3 tags have a different meaning for some models (with format int32u)
@@ -170,19 +743,43 @@
         Writable => 'int16u',
     },
-    0x1003 => { #9 (TX7, panorama mode only)
+    0x1003 => { #9 (64 bytes, contains Panorama info for various DSC, NEX, SLT and DSLR models)
         Name => 'Panorama',
+        # panorama: first 4 bytes '1 1 0 0' (little-endian) or '0 0 1 1' (big-endian)
+        # non-panorama: all bytes are '0' (ref JR)
+        Condition => '$$self{Panorama} = ($$valPt =~ /^(\0\0)?\x01\x01/)', # (little- or big-endian int32u = 257)
         SubDirectory => { TagTable => 'Image::ExifTool::Sony::Panorama' },
     },
+    # 0x2000 - undef[1]
     0x2001 => { #PH (JPEG images from all DSLR's except the A100)
         Name => 'PreviewImage',
+        Groups => { 2 => 'Preview' },
         Writable => 'undef',
         DataTag => 'PreviewImage',
+        Notes => 'HD-size preview in JPEG images from almost all DSLR/SLT/ILCA/NEX/ILCE.',
         # Note: the preview data starts with a 32-byte proprietary Sony header
+        #       first 8 bytes after 32-byte header:
+        #          \x00\xd8\xff\xe1\x00\x27\xff\xff for JPEG files from A33/35/55V/450/500/550/560/580, NEX-3/5/5C/C3/VG10
+        #          \x00\xd8\xff\xdb\x00\x84\x00\x01 for JPEG files from all other models
+        #        ( \xff\xd8\xff\xdb\x00\x84\x00\x01 corresponding bytes for all ARW files )
+        #
+        # DSLR-A700/A850/A900 and DSLR-A200/A300/A350:
+        # - no MPImage2
+        # DSLR-A230/A290/A330/A380/A390:
+        # - PreviewImage start-offset is at 110 bytes inside MPImage2
+        # DSLR-A450/A500/A550/A560/A580, SLT-A33/A35/A55V, NEX-3/5/5C/C3/VG10/VG10E:
+        # - PreviewImage start-offset is at 106 bytes inside MPImage2
+        # - different first bytes after 32-byte header
+        # SLT-A37/A57/A58/A65V/A77V/A99V, ILCA-77M2, NEX-3N/5N/5R/5T/6/7/F3, ILCE-3000/3500/5000/6000/7/7R/7S:
+        # - PreviewImage start-offset is at 130 bytes inside MPImage2
+        # NEX-VG20E/VG30E/VG900, ILCE-QX1: 0x2001 not present
+        # ILCE-5100/ILCE-7M2/7RM2/7SM2   : 0x2001 present but Size 0 and Offset 0
+        #
         WriteCheck => 'return $val=~/^(none|.{32}\xff\xd8\xff)/s ? undef : "Not a valid image"',
         RawConv => q{
             return \$val if $val =~ /^Binary/;
             $val = substr($val,0x20) if length($val) > 0x20;
-            return \$val if $val =~ s/^.(\xd8\xff\xdb)/\xff$1/s;
-            $$self{PreviewError} = 1 unless $val eq 'none';
+#            return \$val if $val =~ s/^.(\xd8\xff\xdb)/\xff$1/s;
+            return \$val if $val =~ s/^.(\xd8\xff[\xdb\xe1])/\xff$1/s;
+            $$self{PreviewError} = 1 unless $val eq 'none' or $val eq '';
             return undef;
         },
@@ -197,5 +794,9 @@
         },
     },
-    # 0x2002 - probably Sharpness (PH guess)
+    0x2002 => { #JR (written by Sony IDC)
+        Name => 'Rating',
+        Writable => 'int32u', # (0-5 stars) (4294967295 for an HX9V iSweep Panorama, ref JR)
+    },
+    # 0x2003 - string[256]: all 0 for DSLR, SLT, NEX; data for DSC-HX9V
     0x2004 => { #PH (NEX-5)
         Name => 'Contrast',
@@ -228,7 +829,8 @@
         PrintConv => {
             0 => 'Off',
-            1 => 'On',
-            0xffff0000 => 'Off 2',
-            0xffff0001 => 'On 2',
+            1 => 'On (unused)',
+            0x10001 => 'On (dark subtracted)', # (NEX-C3)
+            0xffff0000 => 'Off (65535)',
+            0xffff0001 => 'On (65535)',
             0xffffffff => 'n/a',
         },
@@ -243,4 +845,5 @@
             3 => 'High',
             256 => 'Auto',
+            # it seems that all DSC models except DSC-RX models give n/a here (ref JR)
             65535 => 'n/a',
         },
@@ -249,24 +852,33 @@
         Name => 'HDR',
         Writable => 'int32u',
+        Format => 'int16u',
+        Count => 2,
+        Notes => 'stored as a 32-bit integer, but read as two 16-bit integers',
         PrintHex => 1,
-        PrintConv => {
+        PrintConv => [{
             0x0 => 'Off',
-            0x10001 => 'Auto',
-            0x10010 => '1.0 EV', # (NEX_5)
-            0x10011 => '1.5 EV',
-            0x10012 => '2.0 EV',
-            0x10013 => '2.5 EV',
-            0x10014 => '3.0 EV',
-            0x10015 => '3.5 EV',
-            0x10016 => '4.0 EV',
-            0x10017 => '4.5 EV',
-            0x10018 => '5.0 EV',
-            0x10019 => '5.5 EV',
-            0x1001a => '6.0 EV', # (SLT-A55V)
-        },
+            0x01 => 'Auto',
+            0x10 => '1.0 EV',
+            0x11 => '1.5 EV',
+            0x12 => '2.0 EV',
+            0x13 => '2.5 EV',
+            0x14 => '3.0 EV',
+            0x15 => '3.5 EV',
+            0x16 => '4.0 EV',
+            0x17 => '4.5 EV',
+            0x18 => '5.0 EV',
+            0x19 => '5.5 EV',
+            0x1a => '6.0 EV',
+        },{ #JR (A580)
+            0 => 'Uncorrected image',  # A580 stores 2 images: uncorrected and HDR
+            1 => 'HDR image (good)',
+            2 => 'HDR image (fail 1)', # alignment problem?
+            3 => 'HDR image (fail 2)', # contrast problem?
+        }],
     },
     0x200b => { #PH
         Name => 'MultiFrameNoiseReduction',
         Writable => 'int32u',
+        Notes => 'may not be valid for RS100', # (RS100 sample was 0 when this feature was turned on)
         PrintConv => {
             0 => 'Off',
